package Box2D.Dynamics.Joints
{
   import Box2D.Common.Math._oh327;
   import Box2D.Common.Math.b2Vec2;
   import Box2D.Common._kc225;
   import Box2D.Dynamics._th791;
   import Box2D.Dynamics._ut97;
   
   public class _sj166 extends _yw701
   {
      public var m_beta:Number;
      
      public var m_mass:_oh327;
      
      public var m_target:b2Vec2;
      
      public var m_impulse:b2Vec2;
      
      public var m_localAnchor:b2Vec2;
      
      private var K:_oh327;
      
      private var K1:_oh327;
      
      private var K2:_oh327;
      
      public var m_gamma:Number;
      
      public var m_C:b2Vec2;
      
      public var m_maxForce:Number;
      
      public function _sj166(param1:_id705)
      {
         var _loc2_:Number = NaN;
         var _loc3_:Number = NaN;
         var _loc4_:_oh327 = null;
         var _loc5_:Number = NaN;
         var _loc6_:Number = NaN;
         var _loc7_:Number = NaN;
         var _loc8_:Number = NaN;
         K = new _oh327();
         K1 = new _oh327();
         K2 = new _oh327();
         m_localAnchor = new b2Vec2();
         m_target = new b2Vec2();
         m_impulse = new b2Vec2();
         m_mass = new _oh327();
         m_C = new b2Vec2();
         super(param1);
         m_target._kh737(param1.target);
         _loc2_ = m_target.x - m_body2.m_xf.position.x;
         _loc3_ = m_target.y - m_body2.m_xf.position.y;
         _loc4_ = m_body2.m_xf.R;
         m_localAnchor.x = _loc2_ * _loc4_.col1.x + _loc3_ * _loc4_.col1.y;
         m_localAnchor.y = _loc2_ * _loc4_.col2.x + _loc3_ * _loc4_.col2.y;
         m_maxForce = param1.maxForce;
         m_impulse._he34();
         _loc5_ = m_body2.m_mass;
         _loc6_ = 2 * _kc225.b2_pi * param1.frequencyHz;
         _loc7_ = 2 * _loc5_ * param1.dampingRatio * _loc6_;
         _loc8_ = param1.timeStep * _loc5_ * (_loc6_ * _loc6_);
         m_gamma = 1 / (_loc7_ + _loc8_);
         m_beta = _loc8_ / (_loc7_ + _loc8_);
      }
      
      override public function _xt20() : Number
      {
         return 0;
      }
      
      override public function _md397(param1:_ut97) : void
      {
         var _loc2_:_th791 = null;
         var _loc3_:_oh327 = null;
         var _loc4_:Number = NaN;
         var _loc5_:Number = NaN;
         var _loc6_:Number = NaN;
         var _loc7_:Number = NaN;
         var _loc8_:Number = NaN;
         var _loc9_:Number = NaN;
         var _loc10_:Number = NaN;
         var _loc11_:Number = NaN;
         var _loc12_:Number = NaN;
         var _loc13_:Number = NaN;
         var _loc14_:Number = NaN;
         var _loc15_:Number = NaN;
         var _loc16_:Number = NaN;
         _loc2_ = m_body2;
         _loc3_ = _loc2_.m_xf.R;
         _loc6_ = m_localAnchor.x - _loc2_.m_sweep.localCenter.x;
         _loc7_ = m_localAnchor.y - _loc2_.m_sweep.localCenter.y;
         _loc4_ = _loc3_.col1.x * _loc6_ + _loc3_.col2.x * _loc7_;
         _loc7_ = _loc3_.col1.y * _loc6_ + _loc3_.col2.y * _loc7_;
         _loc6_ = _loc4_;
         _loc8_ = _loc2_.m_linearVelocity.x + -_loc2_.m_angularVelocity * _loc7_;
         _loc9_ = _loc2_.m_linearVelocity.y + _loc2_.m_angularVelocity * _loc6_;
         _loc3_ = m_mass;
         _loc4_ = _loc8_ + m_beta * param1.inv_dt * m_C.x + m_gamma * param1.dt * m_impulse.x;
         _loc5_ = _loc9_ + m_beta * param1.inv_dt * m_C.y + m_gamma * param1.dt * m_impulse.y;
         _loc10_ = -param1.inv_dt * (_loc3_.col1.x * _loc4_ + _loc3_.col2.x * _loc5_);
         _loc11_ = -param1.inv_dt * (_loc3_.col1.y * _loc4_ + _loc3_.col2.y * _loc5_);
         _loc12_ = m_impulse.x;
         _loc13_ = m_impulse.y;
         m_impulse.x += _loc10_;
         m_impulse.y += _loc11_;
         _loc14_ = m_impulse._tq10();
         if(_loc14_ > m_maxForce)
         {
            m_impulse._bx376(m_maxForce / _loc14_);
         }
         _loc10_ = m_impulse.x - _loc12_;
         _loc11_ = m_impulse.y - _loc13_;
         _loc15_ = param1.dt * _loc10_;
         _loc16_ = param1.dt * _loc11_;
         _loc2_.m_linearVelocity.x += _loc2_.m_invMass * _loc15_;
         _loc2_.m_linearVelocity.y += _loc2_.m_invMass * _loc16_;
         _loc2_.m_angularVelocity += _loc2_.m_invI * (_loc6_ * _loc16_ - _loc7_ * _loc15_);
      }
      
      override public function _mf779(param1:_ut97) : void
      {
         var _loc2_:_th791 = null;
         var _loc3_:_oh327 = null;
         var _loc4_:Number = NaN;
         var _loc5_:Number = NaN;
         var _loc6_:Number = NaN;
         var _loc7_:Number = NaN;
         var _loc8_:Number = NaN;
         var _loc9_:Number = NaN;
         var _loc10_:Number = NaN;
         _loc2_ = m_body2;
         _loc3_ = _loc2_.m_xf.R;
         _loc4_ = m_localAnchor.x - _loc2_.m_sweep.localCenter.x;
         _loc5_ = m_localAnchor.y - _loc2_.m_sweep.localCenter.y;
         _loc6_ = _loc3_.col1.x * _loc4_ + _loc3_.col2.x * _loc5_;
         _loc5_ = _loc3_.col1.y * _loc4_ + _loc3_.col2.y * _loc5_;
         _loc4_ = _loc6_;
         _loc7_ = _loc2_.m_invMass;
         _loc8_ = _loc2_.m_invI;
         K1.col1.x = _loc7_;
         K1.col2.x = 0;
         K1.col1.y = 0;
         K1.col2.y = _loc7_;
         K2.col1.x = _loc8_ * _loc5_ * _loc5_;
         K2.col2.x = -_loc8_ * _loc4_ * _loc5_;
         K2.col1.y = -_loc8_ * _loc4_ * _loc5_;
         K2.col2.y = _loc8_ * _loc4_ * _loc4_;
         K._kp63(K1);
         K._lk586(K2);
         K.col1.x += m_gamma;
         K.col2.y += m_gamma;
         K._ma772(m_mass);
         m_C.x = _loc2_.m_sweep.c.x + _loc4_ - m_target.x;
         m_C.y = _loc2_.m_sweep.c.y + _loc5_ - m_target.y;
         _loc2_.m_angularVelocity *= 0.98;
         _loc9_ = param1.dt * m_impulse.x;
         _loc10_ = param1.dt * m_impulse.y;
         _loc2_.m_linearVelocity.x += _loc7_ * _loc9_;
         _loc2_.m_linearVelocity.y += _loc7_ * _loc10_;
         _loc2_.m_angularVelocity += _loc8_ * (_loc4_ * _loc10_ - _loc5_ * _loc9_);
      }
      
      override public function _va771() : b2Vec2
      {
         return m_body2._pj447(m_localAnchor);
      }
      
      override public function _ms688() : b2Vec2
      {
         return m_target;
      }
      
      public function _ft269(param1:b2Vec2) : void
      {
         if(m_body2._bk718())
         {
            m_body2._uo631();
         }
         m_target = param1;
      }
      
      override public function _mx220() : b2Vec2
      {
         return m_impulse;
      }
      
      override public function _sl623() : Boolean
      {
         return true;
      }
   }
}

