package Box2D.Dynamics.Joints
{
   import Box2D.Common.Math.b2Vec2;
   import Box2D.Dynamics._th791;
   
   public class _xm825 extends _es399
   {
      public var maxLength2:Number;
      
      public var length1:Number;
      
      public var length2:Number;
      
      public var maxLength1:Number;
      
      public var ratio:Number;
      
      public var groundAnchor1:b2Vec2;
      
      public var groundAnchor2:b2Vec2;
      
      public var localAnchor1:b2Vec2;
      
      public var localAnchor2:b2Vec2;
      
      public function _xm825()
      {
         groundAnchor1 = new b2Vec2();
         groundAnchor2 = new b2Vec2();
         localAnchor1 = new b2Vec2();
         localAnchor2 = new b2Vec2();
         super();
         type = _yw701.e_pulleyJoint;
         groundAnchor1._br741(-1,1);
         groundAnchor2._br741(1,1);
         localAnchor1._br741(-1,0);
         localAnchor2._br741(1,0);
         length1 = 0;
         maxLength1 = 0;
         length2 = 0;
         maxLength2 = 0;
         ratio = 1;
         collideConnected = true;
      }
      
      public function _cp216(param1:_th791, param2:_th791, param3:b2Vec2, param4:b2Vec2, param5:b2Vec2, param6:b2Vec2, param7:Number) : void
      {
         var _loc8_:Number = NaN;
         var _loc9_:Number = NaN;
         var _loc10_:Number = NaN;
         var _loc11_:Number = NaN;
         var _loc12_:Number = NaN;
         body1 = param1;
         body2 = param2;
         groundAnchor1._kh737(param3);
         groundAnchor2._kh737(param4);
         localAnchor1 = body1._lx197(param5);
         localAnchor2 = body2._lx197(param6);
         _loc8_ = param5.x - param3.x;
         _loc9_ = param5.y - param3.y;
         length1 = Math.sqrt(_loc8_ * _loc8_ + _loc9_ * _loc9_);
         _loc10_ = param6.x - param4.x;
         _loc11_ = param6.y - param4.y;
         length2 = Math.sqrt(_loc10_ * _loc10_ + _loc11_ * _loc11_);
         ratio = param7;
         _loc12_ = length1 + ratio * length2;
         maxLength1 = _loc12_ - ratio * _av415.b2_minPulleyLength;
         maxLength2 = (_loc12_ - _av415.b2_minPulleyLength) / ratio;
      }
   }
}

