package Box2D.Dynamics.Joints
{
   import Box2D.Common.Math.b2Vec2;
   import Box2D.Dynamics._th791;
   import Box2D.Dynamics._ut97;
   
   public class _yw701
   {
      public static const e_unknownJoint:int = 0;
      
      public static const e_revoluteJoint:int = 1;
      
      public static const e_prismaticJoint:int = 2;
      
      public static const e_distanceJoint:int = 3;
      
      public static const e_pulleyJoint:int = 4;
      
      public static const e_mouseJoint:int = 5;
      
      public static const e_gearJoint:int = 6;
      
      public static const e_inactiveLimit:int = 0;
      
      public static const e_atLowerLimit:int = 1;
      
      public static const e_atUpperLimit:int = 2;
      
      public static const e_equalLimits:int = 3;
      
      public var m_islandFlag:Boolean;
      
      public var m_collideConnected:Boolean;
      
      public var m_prev:_yw701;
      
      public var m_type:int;
      
      public var m_next:_yw701;
      
      public var m_node1:_gs664;
      
      public var m_node2:_gs664;
      
      public var m_userData:*;
      
      public var m_inv_dt:Number;
      
      public var m_body1:_th791;
      
      public var m_body2:_th791;
      
      public function _yw701(param1:_es399)
      {
         m_node1 = new _gs664();
         m_node2 = new _gs664();
         super();
         m_type = param1.type;
         m_prev = null;
         m_next = null;
         m_body1 = param1.body1;
         m_body2 = param1.body2;
         m_collideConnected = param1.collideConnected;
         m_islandFlag = false;
         m_userData = param1.userData;
      }
      
      public static function _em71(param1:_es399, param2:*) : _yw701
      {
         var _loc3_:_yw701 = null;
         _loc3_ = null;
         switch(param1.type)
         {
            case e_distanceJoint:
               _loc3_ = new _rx473(param1 as _ft687);
               break;
            case e_mouseJoint:
               _loc3_ = new _sj166(param1 as _id705);
               break;
            case e_prismaticJoint:
               _loc3_ = new _jd407(param1 as _lf111);
               break;
            case e_revoluteJoint:
               _loc3_ = new _af232(param1 as _fa684);
               break;
            case e_pulleyJoint:
               _loc3_ = new _av415(param1 as _xm825);
               break;
            case e_gearJoint:
               _loc3_ = new _ng628(param1 as _ax16);
         }
         return _loc3_;
      }
      
      public static function _ai321(param1:_yw701, param2:*) : void
      {
      }
      
      public function _du520() : _th791
      {
         return m_body1;
      }
      
      public function _dn30() : _th791
      {
         return m_body2;
      }
      
      public function _ix313() : _yw701
      {
         return m_next;
      }
      
      public function _va771() : b2Vec2
      {
         return null;
      }
      
      public function _ya416(param1:*) : void
      {
         m_userData = param1;
      }
      
      public function _wv554() : *
      {
         return m_userData;
      }
      
      public function _ms688() : b2Vec2
      {
         return null;
      }
      
      public function _xt20() : Number
      {
         return 0;
      }
      
      public function _md397(param1:_ut97) : void
      {
      }
      
      public function _mf779(param1:_ut97) : void
      {
      }
      
      public function _mv73() : void
      {
      }
      
      public function _bm330() : int
      {
         return m_type;
      }
      
      public function _mx220() : b2Vec2
      {
         return null;
      }
      
      public function _sl623() : Boolean
      {
         return false;
      }
   }
}

