package Box2D.Dynamics.Joints
{
   import Box2D.Common.Math._oh327;
   import Box2D.Common.Math._ui293;
   import Box2D.Common.Math.b2Vec2;
   import Box2D.Common._kc225;
   import Box2D.Dynamics._th791;
   import Box2D.Dynamics._ut97;
   
   public class _jd407 extends _yw701
   {
      public var m_limitForce:Number;
      
      public var m_refAngle:Number;
      
      public var m_lowerTranslation:Number;
      
      public var m_torque:Number;
      
      public var m_localXAxis1:b2Vec2;
      
      public var m_motorForce:Number;
      
      public var m_limitState:int;
      
      public var m_enableLimit:Boolean;
      
      public var m_localYAxis1:b2Vec2;
      
      public var m_force:Number;
      
      public var m_motorMass:Number;
      
      public var m_maxMotorForce:Number;
      
      public var m_upperTranslation:Number;
      
      public var m_localAnchor2:b2Vec2;
      
      public var m_localAnchor1:b2Vec2;
      
      public var m_angularMass:Number;
      
      public var m_motorJacobian:_ih179;
      
      public var m_motorSpeed:Number;
      
      public var m_linearJacobian:_ih179;
      
      public var m_enableMotor:Boolean;
      
      public var m_limitPositionImpulse:Number;
      
      public var m_linearMass:Number;
      
      public function _jd407(param1:_lf111)
      {
         var _loc2_:_oh327 = null;
         var _loc3_:Number = NaN;
         var _loc4_:Number = NaN;
         m_localAnchor1 = new b2Vec2();
         m_localAnchor2 = new b2Vec2();
         m_localXAxis1 = new b2Vec2();
         m_localYAxis1 = new b2Vec2();
         m_linearJacobian = new _ih179();
         m_motorJacobian = new _ih179();
         super(param1);
         m_localAnchor1._kh737(param1.localAnchor1);
         m_localAnchor2._kh737(param1.localAnchor2);
         m_localXAxis1._kh737(param1.localAxis1);
         m_localYAxis1.x = -m_localXAxis1.y;
         m_localYAxis1.y = m_localXAxis1.x;
         m_refAngle = param1.referenceAngle;
         m_linearJacobian._he34();
         m_linearMass = 0;
         m_force = 0;
         m_angularMass = 0;
         m_torque = 0;
         m_motorJacobian._he34();
         m_motorMass = 0;
         m_motorForce = 0;
         m_limitForce = 0;
         m_limitPositionImpulse = 0;
         m_lowerTranslation = param1.lowerTranslation;
         m_upperTranslation = param1.upperTranslation;
         m_maxMotorForce = param1.maxMotorForce;
         m_motorSpeed = param1.motorSpeed;
         m_enableLimit = param1.enableLimit;
         m_enableMotor = param1.enableMotor;
      }
      
      public function _ap274() : Number
      {
         return m_motorForce;
      }
      
      public function _ox311() : Number
      {
         var _loc1_:_th791 = null;
         var _loc2_:_th791 = null;
         var _loc3_:_oh327 = null;
         var _loc4_:b2Vec2 = null;
         var _loc5_:b2Vec2 = null;
         var _loc6_:Number = NaN;
         var _loc7_:Number = NaN;
         var _loc8_:b2Vec2 = null;
         var _loc9_:Number = NaN;
         _loc1_ = m_body1;
         _loc2_ = m_body2;
         _loc4_ = _loc1_._pj447(m_localAnchor1);
         _loc5_ = _loc2_._pj447(m_localAnchor2);
         _loc6_ = _loc5_.x - _loc4_.x;
         _loc7_ = _loc5_.y - _loc4_.y;
         _loc8_ = _loc1_._st453(m_localXAxis1);
         return _loc8_.x * _loc6_ + _loc8_.y * _loc7_;
      }
      
      public function _nx630() : Number
      {
         return m_motorSpeed;
      }
      
      public function _hi565() : Number
      {
         return m_upperTranslation;
      }
      
      override public function _md397(param1:_ut97) : void
      {
         var _loc2_:_th791 = null;
         var _loc3_:_th791 = null;
         var _loc4_:Number = NaN;
         var _loc5_:Number = NaN;
         var _loc6_:Number = NaN;
         var _loc7_:Number = NaN;
         var _loc8_:Number = NaN;
         var _loc9_:Number = NaN;
         var _loc10_:Number = NaN;
         var _loc11_:Number = NaN;
         var _loc12_:Number = NaN;
         var _loc13_:Number = NaN;
         var _loc14_:Number = NaN;
         var _loc15_:Number = NaN;
         var _loc16_:Number = NaN;
         var _loc17_:Number = NaN;
         var _loc18_:Number = NaN;
         var _loc19_:Number = NaN;
         _loc2_ = m_body1;
         _loc3_ = m_body2;
         _loc4_ = _loc2_.m_invMass;
         _loc5_ = _loc3_.m_invMass;
         _loc6_ = _loc2_.m_invI;
         _loc7_ = _loc3_.m_invI;
         _loc9_ = m_linearJacobian._xn162(_loc2_.m_linearVelocity,_loc2_.m_angularVelocity,_loc3_.m_linearVelocity,_loc3_.m_angularVelocity);
         _loc10_ = -param1.inv_dt * m_linearMass * _loc9_;
         m_force += _loc10_;
         _loc11_ = param1.dt * _loc10_;
         _loc2_.m_linearVelocity.x += _loc4_ * _loc11_ * m_linearJacobian.linear1.x;
         _loc2_.m_linearVelocity.y += _loc4_ * _loc11_ * m_linearJacobian.linear1.y;
         _loc2_.m_angularVelocity += _loc6_ * _loc11_ * m_linearJacobian.angular1;
         _loc3_.m_linearVelocity.x += _loc5_ * _loc11_ * m_linearJacobian.linear2.x;
         _loc3_.m_linearVelocity.y += _loc5_ * _loc11_ * m_linearJacobian.linear2.y;
         _loc3_.m_angularVelocity += _loc7_ * _loc11_ * m_linearJacobian.angular2;
         _loc12_ = _loc3_.m_angularVelocity - _loc2_.m_angularVelocity;
         _loc13_ = -param1.inv_dt * m_angularMass * _loc12_;
         m_torque += _loc13_;
         _loc14_ = param1.dt * _loc13_;
         _loc2_.m_angularVelocity -= _loc6_ * _loc14_;
         _loc3_.m_angularVelocity += _loc7_ * _loc14_;
         if(m_enableMotor && m_limitState != e_equalLimits)
         {
            _loc15_ = m_motorJacobian._xn162(_loc2_.m_linearVelocity,_loc2_.m_angularVelocity,_loc3_.m_linearVelocity,_loc3_.m_angularVelocity) - m_motorSpeed;
            _loc16_ = -param1.inv_dt * m_motorMass * _loc15_;
            _loc17_ = m_motorForce;
            m_motorForce = _ui293._mx500(m_motorForce + _loc16_,-m_maxMotorForce,m_maxMotorForce);
            _loc16_ = m_motorForce - _loc17_;
            _loc11_ = param1.dt * _loc16_;
            _loc2_.m_linearVelocity.x += _loc4_ * _loc11_ * m_motorJacobian.linear1.x;
            _loc2_.m_linearVelocity.y += _loc4_ * _loc11_ * m_motorJacobian.linear1.y;
            _loc2_.m_angularVelocity += _loc6_ * _loc11_ * m_motorJacobian.angular1;
            _loc3_.m_linearVelocity.x += _loc5_ * _loc11_ * m_motorJacobian.linear2.x;
            _loc3_.m_linearVelocity.y += _loc5_ * _loc11_ * m_motorJacobian.linear2.y;
            _loc3_.m_angularVelocity += _loc7_ * _loc11_ * m_motorJacobian.angular2;
         }
         if(m_enableLimit && m_limitState != e_inactiveLimit)
         {
            _loc18_ = m_motorJacobian._xn162(_loc2_.m_linearVelocity,_loc2_.m_angularVelocity,_loc3_.m_linearVelocity,_loc3_.m_angularVelocity);
            _loc19_ = -param1.inv_dt * m_motorMass * _loc18_;
            if(m_limitState == e_equalLimits)
            {
               m_limitForce += _loc19_;
            }
            else if(m_limitState == e_atLowerLimit)
            {
               _loc8_ = m_limitForce;
               m_limitForce = _ui293._bk45(m_limitForce + _loc19_,0);
               _loc19_ = m_limitForce - _loc8_;
            }
            else if(m_limitState == e_atUpperLimit)
            {
               _loc8_ = m_limitForce;
               m_limitForce = _ui293._ct557(m_limitForce + _loc19_,0);
               _loc19_ = m_limitForce - _loc8_;
            }
            _loc11_ = param1.dt * _loc19_;
            _loc2_.m_linearVelocity.x += _loc4_ * _loc11_ * m_motorJacobian.linear1.x;
            _loc2_.m_linearVelocity.y += _loc4_ * _loc11_ * m_motorJacobian.linear1.y;
            _loc2_.m_angularVelocity += _loc6_ * _loc11_ * m_motorJacobian.angular1;
            _loc3_.m_linearVelocity.x += _loc5_ * _loc11_ * m_motorJacobian.linear2.x;
            _loc3_.m_linearVelocity.y += _loc5_ * _loc11_ * m_motorJacobian.linear2.y;
            _loc3_.m_angularVelocity += _loc7_ * _loc11_ * m_motorJacobian.angular2;
         }
      }
      
      public function _rh631() : Number
      {
         var _loc1_:_th791 = null;
         var _loc2_:_th791 = null;
         var _loc3_:_oh327 = null;
         var _loc4_:Number = NaN;
         var _loc5_:Number = NaN;
         var _loc6_:Number = NaN;
         var _loc7_:Number = NaN;
         var _loc8_:Number = NaN;
         var _loc9_:Number = NaN;
         var _loc10_:Number = NaN;
         var _loc11_:Number = NaN;
         var _loc12_:Number = NaN;
         var _loc13_:Number = NaN;
         var _loc14_:Number = NaN;
         var _loc15_:b2Vec2 = null;
         var _loc16_:b2Vec2 = null;
         var _loc17_:b2Vec2 = null;
         var _loc18_:Number = NaN;
         var _loc19_:Number = NaN;
         var _loc20_:Number = NaN;
         _loc1_ = m_body1;
         _loc2_ = m_body2;
         _loc3_ = _loc1_.m_xf.R;
         _loc4_ = m_localAnchor1.x - _loc1_.m_sweep.localCenter.x;
         _loc5_ = m_localAnchor1.y - _loc1_.m_sweep.localCenter.y;
         _loc6_ = _loc3_.col1.x * _loc4_ + _loc3_.col2.x * _loc5_;
         _loc5_ = _loc3_.col1.y * _loc4_ + _loc3_.col2.y * _loc5_;
         _loc4_ = _loc6_;
         _loc3_ = _loc2_.m_xf.R;
         _loc7_ = m_localAnchor2.x - _loc2_.m_sweep.localCenter.x;
         _loc8_ = m_localAnchor2.y - _loc2_.m_sweep.localCenter.y;
         _loc6_ = _loc3_.col1.x * _loc7_ + _loc3_.col2.x * _loc8_;
         _loc8_ = _loc3_.col1.y * _loc7_ + _loc3_.col2.y * _loc8_;
         _loc7_ = _loc6_;
         _loc9_ = _loc1_.m_sweep.c.x + _loc4_;
         _loc10_ = _loc1_.m_sweep.c.y + _loc5_;
         _loc11_ = _loc2_.m_sweep.c.x + _loc7_;
         _loc12_ = _loc2_.m_sweep.c.y + _loc8_;
         _loc13_ = _loc11_ - _loc9_;
         _loc14_ = _loc12_ - _loc10_;
         _loc15_ = _loc1_._st453(m_localXAxis1);
         _loc16_ = _loc1_.m_linearVelocity;
         _loc17_ = _loc2_.m_linearVelocity;
         _loc18_ = _loc1_.m_angularVelocity;
         _loc19_ = _loc2_.m_angularVelocity;
         return _loc13_ * (-_loc18_ * _loc15_.y) + _loc14_ * (_loc18_ * _loc15_.x) + (_loc15_.x * (_loc17_.x + -_loc19_ * _loc8_ - _loc16_.x - -_loc18_ * _loc5_) + _loc15_.y * (_loc17_.y + _loc19_ * _loc7_ - _loc16_.y - _loc18_ * _loc4_));
      }
      
      override public function _xt20() : Number
      {
         return m_torque;
      }
      
      override public function _mf779(param1:_ut97) : void
      {
         var _loc2_:_th791 = null;
         var _loc3_:_th791 = null;
         var _loc4_:_oh327 = null;
         var _loc5_:Number = NaN;
         var _loc6_:Number = NaN;
         var _loc7_:Number = NaN;
         var _loc8_:Number = NaN;
         var _loc9_:Number = NaN;
         var _loc10_:Number = NaN;
         var _loc11_:Number = NaN;
         var _loc12_:Number = NaN;
         var _loc13_:Number = NaN;
         var _loc14_:Number = NaN;
         var _loc15_:Number = NaN;
         var _loc16_:Number = NaN;
         var _loc17_:Number = NaN;
         var _loc18_:Number = NaN;
         var _loc19_:Number = NaN;
         var _loc20_:Number = NaN;
         var _loc21_:Number = NaN;
         var _loc22_:Number = NaN;
         var _loc23_:Number = NaN;
         var _loc24_:Number = NaN;
         var _loc25_:Number = NaN;
         var _loc26_:Number = NaN;
         var _loc27_:Number = NaN;
         var _loc28_:Number = NaN;
         _loc2_ = m_body1;
         _loc3_ = m_body2;
         _loc4_ = _loc2_.m_xf.R;
         _loc6_ = m_localAnchor1.x - _loc2_.m_sweep.localCenter.x;
         _loc7_ = m_localAnchor1.y - _loc2_.m_sweep.localCenter.y;
         _loc5_ = _loc4_.col1.x * _loc6_ + _loc4_.col2.x * _loc7_;
         _loc7_ = _loc4_.col1.y * _loc6_ + _loc4_.col2.y * _loc7_;
         _loc6_ = _loc5_;
         _loc4_ = _loc3_.m_xf.R;
         _loc8_ = m_localAnchor2.x - _loc3_.m_sweep.localCenter.x;
         _loc9_ = m_localAnchor2.y - _loc3_.m_sweep.localCenter.y;
         _loc5_ = _loc4_.col1.x * _loc8_ + _loc4_.col2.x * _loc9_;
         _loc9_ = _loc4_.col1.y * _loc8_ + _loc4_.col2.y * _loc9_;
         _loc8_ = _loc5_;
         _loc10_ = _loc2_.m_invMass;
         _loc11_ = _loc3_.m_invMass;
         _loc12_ = _loc2_.m_invI;
         _loc13_ = _loc3_.m_invI;
         _loc4_ = _loc2_.m_xf.R;
         _loc14_ = _loc4_.col1.x * m_localYAxis1.x + _loc4_.col2.x * m_localYAxis1.y;
         _loc15_ = _loc4_.col1.y * m_localYAxis1.x + _loc4_.col2.y * m_localYAxis1.y;
         _loc16_ = _loc3_.m_sweep.c.x + _loc8_ - _loc2_.m_sweep.c.x;
         _loc17_ = _loc3_.m_sweep.c.y + _loc9_ - _loc2_.m_sweep.c.y;
         m_linearJacobian.linear1.x = -_loc14_;
         m_linearJacobian.linear1.y = -_loc15_;
         m_linearJacobian.linear2.x = _loc14_;
         m_linearJacobian.linear2.y = _loc15_;
         m_linearJacobian.angular1 = -(_loc16_ * _loc15_ - _loc17_ * _loc14_);
         m_linearJacobian.angular2 = _loc8_ * _loc15_ - _loc9_ * _loc14_;
         m_linearMass = _loc10_ + _loc12_ * m_linearJacobian.angular1 * m_linearJacobian.angular1 + _loc11_ + _loc13_ * m_linearJacobian.angular2 * m_linearJacobian.angular2;
         m_linearMass = 1 / m_linearMass;
         m_angularMass = _loc12_ + _loc13_;
         if(m_angularMass > Number.MIN_VALUE)
         {
            m_angularMass = 1 / m_angularMass;
         }
         if(m_enableLimit || m_enableMotor)
         {
            _loc4_ = _loc2_.m_xf.R;
            _loc18_ = _loc4_.col1.x * m_localXAxis1.x + _loc4_.col2.x * m_localXAxis1.y;
            _loc19_ = _loc4_.col1.y * m_localXAxis1.x + _loc4_.col2.y * m_localXAxis1.y;
            m_motorJacobian.linear1.x = -_loc18_;
            m_motorJacobian.linear1.y = -_loc19_;
            m_motorJacobian.linear2.x = _loc18_;
            m_motorJacobian.linear2.y = _loc19_;
            m_motorJacobian.angular1 = -(_loc16_ * _loc19_ - _loc17_ * _loc18_);
            m_motorJacobian.angular2 = _loc8_ * _loc19_ - _loc9_ * _loc18_;
            m_motorMass = _loc10_ + _loc12_ * m_motorJacobian.angular1 * m_motorJacobian.angular1 + _loc11_ + _loc13_ * m_motorJacobian.angular2 * m_motorJacobian.angular2;
            m_motorMass = 1 / m_motorMass;
            if(m_enableLimit)
            {
               _loc20_ = _loc16_ - _loc6_;
               _loc21_ = _loc17_ - _loc7_;
               _loc22_ = _loc18_ * _loc20_ + _loc19_ * _loc21_;
               if(_ui293._if129(m_upperTranslation - m_lowerTranslation) < 2 * _kc225.b2_linearSlop)
               {
                  m_limitState = e_equalLimits;
               }
               else if(_loc22_ <= m_lowerTranslation)
               {
                  if(m_limitState != e_atLowerLimit)
                  {
                     m_limitForce = 0;
                  }
                  m_limitState = e_atLowerLimit;
               }
               else if(_loc22_ >= m_upperTranslation)
               {
                  if(m_limitState != e_atUpperLimit)
                  {
                     m_limitForce = 0;
                  }
                  m_limitState = e_atUpperLimit;
               }
               else
               {
                  m_limitState = e_inactiveLimit;
                  m_limitForce = 0;
               }
            }
         }
         if(m_enableMotor == false)
         {
            m_motorForce = 0;
         }
         if(m_enableLimit == false)
         {
            m_limitForce = 0;
         }
         if(param1.warmStarting)
         {
            _loc23_ = param1.dt * (m_force * m_linearJacobian.linear1.x + (m_motorForce + m_limitForce) * m_motorJacobian.linear1.x);
            _loc24_ = param1.dt * (m_force * m_linearJacobian.linear1.y + (m_motorForce + m_limitForce) * m_motorJacobian.linear1.y);
            _loc25_ = param1.dt * (m_force * m_linearJacobian.linear2.x + (m_motorForce + m_limitForce) * m_motorJacobian.linear2.x);
            _loc26_ = param1.dt * (m_force * m_linearJacobian.linear2.y + (m_motorForce + m_limitForce) * m_motorJacobian.linear2.y);
            _loc27_ = param1.dt * (m_force * m_linearJacobian.angular1 - m_torque + (m_motorForce + m_limitForce) * m_motorJacobian.angular1);
            _loc28_ = param1.dt * (m_force * m_linearJacobian.angular2 + m_torque + (m_motorForce + m_limitForce) * m_motorJacobian.angular2);
            _loc2_.m_linearVelocity.x += _loc10_ * _loc23_;
            _loc2_.m_linearVelocity.y += _loc10_ * _loc24_;
            _loc2_.m_angularVelocity += _loc12_ * _loc27_;
            _loc3_.m_linearVelocity.x += _loc11_ * _loc25_;
            _loc3_.m_linearVelocity.y += _loc11_ * _loc26_;
            _loc3_.m_angularVelocity += _loc13_ * _loc28_;
         }
         else
         {
            m_force = 0;
            m_torque = 0;
            m_limitForce = 0;
            m_motorForce = 0;
         }
         m_limitPositionImpulse = 0;
      }
      
      public function _am566(param1:Boolean) : void
      {
         m_enableMotor = param1;
      }
      
      public function _iq252(param1:Number) : void
      {
         m_motorSpeed = param1;
      }
      
      public function _pd489() : Boolean
      {
         return m_enableLimit;
      }
      
      public function _ao440(param1:Number, param2:Number) : void
      {
         m_lowerTranslation = param1;
         m_upperTranslation = param2;
      }
      
      override public function _va771() : b2Vec2
      {
         return m_body2._pj447(m_localAnchor2);
      }
      
      public function _mt254() : Boolean
      {
         return m_enableMotor;
      }
      
      override public function _ms688() : b2Vec2
      {
         return m_body1._pj447(m_localAnchor1);
      }
      
      public function _iv315() : Number
      {
         return m_lowerTranslation;
      }
      
      public function _gw134(param1:Boolean) : void
      {
         m_enableLimit = param1;
      }
      
      public function _nr22(param1:Number) : void
      {
         m_maxMotorForce = param1;
      }
      
      override public function _mx220() : b2Vec2
      {
         var _loc1_:_oh327 = null;
         var _loc2_:Number = NaN;
         var _loc3_:Number = NaN;
         var _loc4_:Number = NaN;
         var _loc5_:Number = NaN;
         _loc1_ = m_body1.m_xf.R;
         _loc2_ = m_limitForce * (_loc1_.col1.x * m_localXAxis1.x + _loc1_.col2.x * m_localXAxis1.y);
         _loc3_ = m_limitForce * (_loc1_.col1.y * m_localXAxis1.x + _loc1_.col2.y * m_localXAxis1.y);
         _loc4_ = m_force * (_loc1_.col1.x * m_localYAxis1.x + _loc1_.col2.x * m_localYAxis1.y);
         _loc5_ = m_force * (_loc1_.col1.y * m_localYAxis1.x + _loc1_.col2.y * m_localYAxis1.y);
         return new b2Vec2(m_limitForce * _loc2_ + m_force * _loc4_,m_limitForce * _loc3_ + m_force * _loc5_);
      }
      
      override public function _sl623() : Boolean
      {
         var _loc1_:Number = NaN;
         var _loc2_:Number = NaN;
         var _loc3_:_th791 = null;
         var _loc4_:_th791 = null;
         var _loc5_:Number = NaN;
         var _loc6_:Number = NaN;
         var _loc7_:Number = NaN;
         var _loc8_:Number = NaN;
         var _loc9_:_oh327 = null;
         var _loc10_:Number = NaN;
         var _loc11_:Number = NaN;
         var _loc12_:Number = NaN;
         var _loc13_:Number = NaN;
         var _loc14_:Number = NaN;
         var _loc15_:Number = NaN;
         var _loc16_:Number = NaN;
         var _loc17_:Number = NaN;
         var _loc18_:Number = NaN;
         var _loc19_:Number = NaN;
         var _loc20_:Number = NaN;
         var _loc21_:Number = NaN;
         var _loc22_:Number = NaN;
         var _loc23_:Number = NaN;
         var _loc24_:Number = NaN;
         var _loc25_:Number = NaN;
         var _loc26_:Number = NaN;
         var _loc27_:Number = NaN;
         var _loc28_:Number = NaN;
         var _loc29_:Number = NaN;
         var _loc30_:Number = NaN;
         var _loc31_:Number = NaN;
         var _loc32_:Number = NaN;
         _loc3_ = m_body1;
         _loc4_ = m_body2;
         _loc5_ = _loc3_.m_invMass;
         _loc6_ = _loc4_.m_invMass;
         _loc7_ = _loc3_.m_invI;
         _loc8_ = _loc4_.m_invI;
         _loc9_ = _loc3_.m_xf.R;
         _loc11_ = m_localAnchor1.x - _loc3_.m_sweep.localCenter.x;
         _loc12_ = m_localAnchor1.y - _loc3_.m_sweep.localCenter.y;
         _loc10_ = _loc9_.col1.x * _loc11_ + _loc9_.col2.x * _loc12_;
         _loc12_ = _loc9_.col1.y * _loc11_ + _loc9_.col2.y * _loc12_;
         _loc11_ = _loc10_;
         _loc9_ = _loc4_.m_xf.R;
         _loc13_ = m_localAnchor2.x - _loc4_.m_sweep.localCenter.x;
         _loc14_ = m_localAnchor2.y - _loc4_.m_sweep.localCenter.y;
         _loc10_ = _loc9_.col1.x * _loc13_ + _loc9_.col2.x * _loc14_;
         _loc14_ = _loc9_.col1.y * _loc13_ + _loc9_.col2.y * _loc14_;
         _loc13_ = _loc10_;
         _loc15_ = _loc3_.m_sweep.c.x + _loc11_;
         _loc16_ = _loc3_.m_sweep.c.y + _loc12_;
         _loc17_ = _loc4_.m_sweep.c.x + _loc13_;
         _loc18_ = _loc4_.m_sweep.c.y + _loc14_;
         _loc19_ = _loc17_ - _loc15_;
         _loc20_ = _loc18_ - _loc16_;
         _loc9_ = _loc3_.m_xf.R;
         _loc21_ = _loc9_.col1.x * m_localYAxis1.x + _loc9_.col2.x * m_localYAxis1.y;
         _loc22_ = _loc9_.col1.y * m_localYAxis1.x + _loc9_.col2.y * m_localYAxis1.y;
         _loc23_ = _loc21_ * _loc19_ + _loc22_ * _loc20_;
         _loc23_ = _ui293._mx500(_loc23_,-_kc225.b2_maxLinearCorrection,_kc225.b2_maxLinearCorrection);
         _loc24_ = -m_linearMass * _loc23_;
         _loc3_.m_sweep.c.x += _loc5_ * _loc24_ * m_linearJacobian.linear1.x;
         _loc3_.m_sweep.c.y += _loc5_ * _loc24_ * m_linearJacobian.linear1.y;
         _loc3_.m_sweep.a += _loc7_ * _loc24_ * m_linearJacobian.angular1;
         _loc4_.m_sweep.c.x += _loc6_ * _loc24_ * m_linearJacobian.linear2.x;
         _loc4_.m_sweep.c.y += _loc6_ * _loc24_ * m_linearJacobian.linear2.y;
         _loc4_.m_sweep.a += _loc8_ * _loc24_ * m_linearJacobian.angular2;
         _loc25_ = _ui293._if129(_loc23_);
         _loc26_ = _loc4_.m_sweep.a - _loc3_.m_sweep.a - m_refAngle;
         _loc26_ = _ui293._mx500(_loc26_,-_kc225.b2_maxAngularCorrection,_kc225.b2_maxAngularCorrection);
         _loc27_ = -m_angularMass * _loc26_;
         _loc3_.m_sweep.a -= _loc3_.m_invI * _loc27_;
         _loc4_.m_sweep.a += _loc4_.m_invI * _loc27_;
         _loc3_._tp414();
         _loc4_._tp414();
         _loc28_ = _ui293._if129(_loc26_);
         if(m_enableLimit && m_limitState != e_inactiveLimit)
         {
            _loc9_ = _loc3_.m_xf.R;
            _loc11_ = m_localAnchor1.x - _loc3_.m_sweep.localCenter.x;
            _loc12_ = m_localAnchor1.y - _loc3_.m_sweep.localCenter.y;
            _loc10_ = _loc9_.col1.x * _loc11_ + _loc9_.col2.x * _loc12_;
            _loc12_ = _loc9_.col1.y * _loc11_ + _loc9_.col2.y * _loc12_;
            _loc11_ = _loc10_;
            _loc9_ = _loc4_.m_xf.R;
            _loc13_ = m_localAnchor2.x - _loc4_.m_sweep.localCenter.x;
            _loc14_ = m_localAnchor2.y - _loc4_.m_sweep.localCenter.y;
            _loc10_ = _loc9_.col1.x * _loc13_ + _loc9_.col2.x * _loc14_;
            _loc14_ = _loc9_.col1.y * _loc13_ + _loc9_.col2.y * _loc14_;
            _loc13_ = _loc10_;
            _loc15_ = _loc3_.m_sweep.c.x + _loc11_;
            _loc16_ = _loc3_.m_sweep.c.y + _loc12_;
            _loc17_ = _loc4_.m_sweep.c.x + _loc13_;
            _loc18_ = _loc4_.m_sweep.c.y + _loc14_;
            _loc19_ = _loc17_ - _loc15_;
            _loc20_ = _loc18_ - _loc16_;
            _loc9_ = _loc3_.m_xf.R;
            _loc29_ = _loc9_.col1.x * m_localXAxis1.x + _loc9_.col2.x * m_localXAxis1.y;
            _loc30_ = _loc9_.col1.y * m_localXAxis1.x + _loc9_.col2.y * m_localXAxis1.y;
            _loc31_ = _loc29_ * _loc19_ + _loc30_ * _loc20_;
            _loc32_ = 0;
            if(m_limitState == e_equalLimits)
            {
               _loc1_ = _ui293._mx500(_loc31_,-_kc225.b2_maxLinearCorrection,_kc225.b2_maxLinearCorrection);
               _loc32_ = -m_motorMass * _loc1_;
               _loc25_ = _ui293._bk45(_loc25_,_ui293._if129(_loc26_));
            }
            else if(m_limitState == e_atLowerLimit)
            {
               _loc1_ = _loc31_ - m_lowerTranslation;
               _loc25_ = _ui293._bk45(_loc25_,-_loc1_);
               _loc1_ = _ui293._mx500(_loc1_ + _kc225.b2_linearSlop,-_kc225.b2_maxLinearCorrection,0);
               _loc32_ = -m_motorMass * _loc1_;
               _loc2_ = m_limitPositionImpulse;
               m_limitPositionImpulse = _ui293._bk45(m_limitPositionImpulse + _loc32_,0);
               _loc32_ = m_limitPositionImpulse - _loc2_;
            }
            else if(m_limitState == e_atUpperLimit)
            {
               _loc1_ = _loc31_ - m_upperTranslation;
               _loc25_ = _ui293._bk45(_loc25_,_loc1_);
               _loc1_ = _ui293._mx500(_loc1_ - _kc225.b2_linearSlop,0,_kc225.b2_maxLinearCorrection);
               _loc32_ = -m_motorMass * _loc1_;
               _loc2_ = m_limitPositionImpulse;
               m_limitPositionImpulse = _ui293._ct557(m_limitPositionImpulse + _loc32_,0);
               _loc32_ = m_limitPositionImpulse - _loc2_;
            }
            _loc3_.m_sweep.c.x += _loc5_ * _loc32_ * m_motorJacobian.linear1.x;
            _loc3_.m_sweep.c.y += _loc5_ * _loc32_ * m_motorJacobian.linear1.y;
            _loc3_.m_sweep.a += _loc7_ * _loc32_ * m_motorJacobian.angular1;
            _loc4_.m_sweep.c.x += _loc6_ * _loc32_ * m_motorJacobian.linear2.x;
            _loc4_.m_sweep.c.y += _loc6_ * _loc32_ * m_motorJacobian.linear2.y;
            _loc4_.m_sweep.a += _loc8_ * _loc32_ * m_motorJacobian.angular2;
            _loc3_._tp414();
            _loc4_._tp414();
         }
         return _loc25_ <= _kc225.b2_linearSlop && _loc28_ <= _kc225.b2_angularSlop;
      }
   }
}

